--- sat-solver/CMakeLists.txt.dbhandling~	2009-05-31 22:24:58.000000000 +0200
+++ sat-solver/CMakeLists.txt	2009-06-01 17:07:14.763681956 +0200
@@ -36,11 +36,17 @@ FIND_PACKAGE(Check REQUIRED)
 FIND_PACKAGE(ZLIB REQUIRED)
 
 IF ( FEDORA )
-MESSAGE(STATUS "Building for Fedora")
-ADD_DEFINITIONS( -DFEDORA )
-FIND_LIBRARY(RPMDB_LIBRARY NAMES rpm)
+  MESSAGE(STATUS "Building for Fedora")
+  ADD_DEFINITIONS( -DFEDORA )
+  FIND_LIBRARY(RPMDB_LIBRARY NAMES rpm)
 ELSE ( FEDORA )
-FIND_LIBRARY(RPMDB_LIBRARY NAMES rpmdb)
+  IF ( ARK )
+    MESSAGE(STATUS "Building for Ark")
+    ADD_DEFINITIONS( -DARK )
+    FIND_LIBRARY(RPMDB_LIBRARY NAMES rpm)
+  ELSE ( ARK )
+    FIND_LIBRARY(RPMDB_LIBRARY NAMES rpmdb)
+  ENDIF ( ARK )
 ENDIF ( FEDORA)
 
 SET( PACKAGE "satsolver" )
--- sat-solver/tools/repo_rpmdb.c.dbhandling~	2009-05-31 22:25:01.000000000 +0200
+++ sat-solver/tools/repo_rpmdb.c	2009-06-01 17:09:58.760898106 +0200
@@ -22,11 +22,16 @@
 #include <unistd.h>
 #include <assert.h>
 
-#ifdef FEDORA
+#if defined(FEDORA) || defined(ARK)
 #include <db4/db.h>
 #else
 #include <rpm/db.h>
 #endif
+#ifdef ARK
+#define RPMDB_TYPE DB_BTREE
+#else
+#define RPMDB_TYPE DB_HASH
+#endif
 
 #include "pool.h"
 #include "repo.h"
@@ -1197,7 +1202,7 @@ count_headers(const char *rootdir, DB_EN
       perror("db_create");
       exit(1);
     }
-  if (db->open(db, 0, dbpath, 0, DB_HASH, DB_RDONLY, 0664))
+  if (db->open(db, 0, dbpath, 0, RPMDB_TYPE, DB_RDONLY, 0664))
     {
       perror("db->open var/lib/rpm/Name");
       exit(1);
@@ -1309,7 +1314,7 @@ repo_add_rpmdb(Repo *repo, Repo *ref, co
 
       if ((flags & RPMDB_REPORT_PROGRESS) != 0)
 	count = count_headers(rootdir, dbenv);
-      if (db->open(db, 0, dbpath, 0, DB_HASH, DB_RDONLY, 0664))
+      if (db->open(db, 0, dbpath, 0, RPMDB_TYPE, DB_RDONLY, 0664))
 	{
 	  perror("db->open var/lib/rpm/Packages");
 	  exit(1);
@@ -1424,7 +1429,7 @@ repo_add_rpmdb(Repo *repo, Repo *ref, co
 
       memset(dircache, 0, sizeof(dircache));
       snprintf(dbpath, PATH_MAX, "%s/var/lib/rpm/Name", rootdir);
-      if (db->open(db, 0, dbpath, 0, DB_HASH, DB_RDONLY, 0664))
+      if (db->open(db, 0, dbpath, 0, RPMDB_TYPE, DB_RDONLY, 0664))
 	{
 	  perror("db->open var/lib/rpm/Name");
 	  exit(1);
@@ -1550,7 +1555,7 @@ repo_add_rpmdb(Repo *repo, Repo *ref, co
 		  exit(1);
 		}
 	      snprintf(dbpath, PATH_MAX, "%s/var/lib/rpm/Packages", rootdir);
-	      if (db->open(db, 0, dbpath, 0, DB_HASH, DB_RDONLY, 0664))
+	      if (db->open(db, 0, dbpath, 0, RPMDB_TYPE, DB_RDONLY, 0664))
 		{
 		  perror("db->open var/lib/rpm/Packages");
 		  exit(1);
